diff -crN nakedmudv1.5/src/items/furniture.c nakedmudv2.0/src/items/furniture.c
*** nakedmudv1.5/src/items/furniture.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/furniture.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,175 ----
+ //*****************************************************************************
+ //
+ // furniture.c
+ //
+ // handles all of the functioning of the furniture item type. Stores data about 
+ // the capacity of the furniture, and what type of furniture it is. 
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../storage.h"
+ #include "../object.h"
+ #include "../world.h"
+ #include "../socket.h"
+ #include "../olc2/olc.h"
+ 
+ #include "items.h"
+ #include "iedit.h"
+ #include "furniture.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // item data for furnitures
+ //*****************************************************************************
+ typedef struct furniture_data {
+   int capacity;
+   int type;
+ } FURNITURE_DATA;
+ 
+ FURNITURE_DATA *newFurnitureData() {
+   FURNITURE_DATA *data = malloc(sizeof(FURNITURE_DATA));
+   data->capacity  = 0;
+   data->type      = FURNITURE_AT;
+   return data;
+ }
+ 
+ void deleteFurnitureData(FURNITURE_DATA *data) {
+   free(data);
+ }
+ 
+ void furnitureDataCopyTo(FURNITURE_DATA *from, FURNITURE_DATA *to) {
+   *to = *from;
+ }
+ 
+ FURNITURE_DATA *furnitureDataCopy(FURNITURE_DATA *data) {
+   FURNITURE_DATA *new_data = newFurnitureData();
+   furnitureDataCopyTo(data, new_data);
+   return new_data;
+ }
+ 
+ STORAGE_SET *furnitureDataStore(FURNITURE_DATA *data) {
+   STORAGE_SET *set = new_storage_set();
+   store_int(set, "capacity", data->capacity);
+   store_int(set, "type",     data->type);
+   return set;
+ }
+ 
+ FURNITURE_DATA *furnitureDataRead(STORAGE_SET *set) {
+   FURNITURE_DATA *data = newFurnitureData();
+   data->capacity = read_int(set, "capacity");
+   data->type     = read_int(set, "type");
+   return data;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // functions for interacting with furnitures
+ //*****************************************************************************
+ int furnitureGetCapacity(OBJ_DATA *obj) {
+   FURNITURE_DATA *data = objGetTypeData(obj, "furniture");
+   return data->capacity;
+ }
+ 
+ void furnitureSetCapacity(OBJ_DATA *obj, int capacity) {
+   FURNITURE_DATA *data = objGetTypeData(obj, "furniture");
+   data->capacity = capacity;
+ }
+ 
+ int furnitureGetType(OBJ_DATA *obj) {
+   FURNITURE_DATA *data = objGetTypeData(obj, "furniture");
+   return data->type;
+ }  
+ 
+ void furnitureSetType(OBJ_DATA *obj, int type) {
+   FURNITURE_DATA *data = objGetTypeData(obj, "furniture");
+   data->type = type;
+ }  
+ 
+ const char *furniture_names[NUM_FURNITURES] = {
+   "table furniture",
+   "sitting furniture"
+ };
+ 
+ const char *furnitureTypeGetName(int type) {
+   return furniture_names[type];
+ }
+ 
+ int furnitureTypeGetNum(const char *type) {
+   int i;
+   for(i = 0; i < NUM_FURNITURES; i++)
+     if(!strcasecmp(furniture_names[i], type))
+       return i;
+   return FURNITURE_NONE;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // furniture olc
+ //*****************************************************************************
+ #define IEDIT_FURNITURE_CAPACITY      1
+ #define IEDIT_FURNITURE_TYPE          2
+ 
+ // the resedit olc needs these declared
+ void iedit_furniture_menu(SOCKET_DATA *sock, FURNITURE_DATA *data) {
+   send_to_socket(sock, 
+ 		 "{g1) Capacity : {c%d\r\n"
+ 		 "{g2) Type     : {y[{c%s{y]\r\n",
+ 		 data->capacity,
+ 		 furnitureTypeGetName(data->type));
+ }
+ 
+ int  iedit_furniture_chooser(SOCKET_DATA *sock, FURNITURE_DATA *data, char option) {
+   switch(toupper(option)) {
+   case '1':
+     text_to_buffer(sock, "Enter a new weight capacity for the furniture: ");
+     return IEDIT_FURNITURE_CAPACITY;
+   case '2':
+     olc_display_table(sock, furnitureTypeGetName, NUM_FURNITURES, 1);
+     return IEDIT_FURNITURE_TYPE;
+   default: return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool iedit_furniture_parser (SOCKET_DATA *sock, FURNITURE_DATA *data, int choice, 
+ 			  const char *arg) {
+   switch(choice) {
+   case IEDIT_FURNITURE_CAPACITY: {
+     int capacity = atoi(arg);
+     if(capacity <= 0)
+       return FALSE;
+     data->capacity = capacity;
+     return TRUE;
+   }
+   case IEDIT_FURNITURE_TYPE: {
+     int type = atoi(arg);
+     if(type < 0 || type >= NUM_FURNITURES || !isdigit(*arg))
+       return FALSE;
+     data->type = type;
+     return TRUE;
+   }
+   default: return FALSE;
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // install the furniture item type
+ //*****************************************************************************
+ 
+ //
+ // this will need to be called by init_items() in items/items.c
+ void init_furniture(void) {
+   item_add_type("furniture", 
+   		newFurnitureData, deleteFurnitureData,
+   		furnitureDataCopyTo, furnitureDataCopy, 
+   		furnitureDataStore, furnitureDataRead);
+ 
+   // set up the furniture OLC too
+   item_add_olc("furniture", iedit_furniture_menu, iedit_furniture_chooser, 
+   	       iedit_furniture_parser);
+ }
diff -crN nakedmudv1.5/src/items/furniture.d nakedmudv2.0/src/items/furniture.d
*** nakedmudv1.5/src/items/furniture.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/furniture.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ items/furniture.d items/furniture.o: items/furniture.c mud.h wrapsock.h property_table.h list.h \
+   map.h hashtable.h set.h buffer.h bitvector.h storage.h object.h world.h \
+   socket.h olc2/olc.h items/items.h items/iedit.h items/furniture.h
diff -crN nakedmudv1.5/src/items/furniture.h nakedmudv2.0/src/items/furniture.h
*** nakedmudv1.5/src/items/furniture.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/furniture.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,25 ----
+ #ifndef FURNITURE_H
+ #define FURNITURE_H
+ //*****************************************************************************
+ //
+ // furniture.h
+ //
+ // handles all of the functioning of the furniture item type. Stores data about 
+ // the capacity of the furniture, and what type of furniture it is. 
+ //
+ //*****************************************************************************
+ 
+ #define FURNITURE_NONE       -1
+ #define FURNITURE_AT          0
+ #define FURNITURE_ON          1
+ #define NUM_FURNITURES        2
+ 
+ int  furnitureGetCapacity(OBJ_DATA *obj);
+ void furnitureSetCapacity(OBJ_DATA *obj, int capacity);
+ int  furnitureGetType(OBJ_DATA *obj);
+ void furnitureSetType(OBJ_DATA *obj, int type);
+ 
+ const char *furnitureTypeGetName(int type);
+ int  furnitureTypeGetNum(const char *type);
+ 
+ #endif // FURNITURE_H
diff -crN nakedmudv1.5/src/items/iedit.c nakedmudv2.0/src/items/iedit.c
*** nakedmudv1.5/src/items/iedit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/iedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,146 ----
+ //*****************************************************************************
+ //
+ // iedit.c
+ //
+ // Although it is not core to the functioning of items, we will more likely
+ // than not want to be able to edit their type information in OLC. This will
+ // require a parser, a chooser, and a menu for editing the type information.
+ // Item types can add in their OLC functions via this framework. iedit uses
+ // the OLC2 framework. For more detailed instructions on how to set up an OLC,
+ // users should refer to the OLC2 source headers.
+ //
+ // NOTE: the menu, chooser, and parser should only take the item-specific data,
+ //       and not the WHOLE object! It has been set up this way to encourage
+ //       people to localize all of the data associated with one item type.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../socket.h"
+ #include "items.h"
+ #include "iedit.h"
+ 
+ #include "../olc2/olc.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // local functions, variables, and datastructures
+ //*****************************************************************************
+ 
+ //
+ // how many buckets will be in our item_olc_table? This should be about 120%
+ // bigger than the number of item types we have, although it's not a huge deal.
+ #define IEDIT_TABLE_SIZE       50
+ 
+ // used to store the different sub-olc functions for different item types
+ HASHTABLE *item_olc_table = NULL;
+ 
+ typedef struct item_olc_data {
+   void    (* menu)(SOCKET_DATA *sock, void *data);
+   int  (* chooser)(SOCKET_DATA *sock, void *data, char option);
+   bool  (* parser)(SOCKET_DATA *sock, void *data, int choice, const char *arg);
+ } ITEM_OLC_DATA;
+ 
+ ITEM_OLC_DATA *newItemOLC(void *menu, void *chooser, void *parser) {
+   ITEM_OLC_DATA *data = malloc(sizeof(ITEM_OLC_DATA));
+   data->menu    = menu;
+   data->chooser = chooser;
+   data->parser  = parser;
+   return data;
+ }
+ 
+ void deleteItemOLC(ITEM_OLC_DATA *data) {
+   free(data);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // implementation of iedit.h
+ //*****************************************************************************
+ #define IEDIT_EDIT        1
+ #define IEDIT_DELETE      2
+ 
+ 
+ //
+ // list off all the item types available for editing. Print the type in green
+ // if the item currently is not of that type. Print the type in yellow if the
+ // item is of that type.
+ void iedit_show_types(SOCKET_DATA *sock, OBJ_DATA *obj) {
+   LIST *list = itemTypeList();
+   LIST_ITERATOR *list_i = newListIterator(list);
+   char *type = NULL;
+   int col = 0;
+ 
+   text_to_buffer(sock, "{wEditable item types:\r\n");
+   ITERATE_LIST(type, list_i) {
+     send_to_socket(sock, "  %s%-14s%s", (objIsType(obj, type) ? "{y" : "{g"),
+ 		   type, ((col != 0 && col % 4 == 0) ? "\r\n": "   "));
+     col++;
+   }
+   deleteListIterator(list_i);
+   deleteListWith(list, free);
+ 
+   if(col % 4 != 0) text_to_buffer(sock, "\r\n");
+ }
+ 
+ void item_add_olc(const char *type, void *menu, void *chooser, void *parser) {
+   ITEM_OLC_DATA *data = NULL;
+   // check to see if we already have functions for this item type installed
+   if( (data = hashRemove(item_olc_table, type)) != NULL)
+     deleteItemOLC(data);
+   data = newItemOLC(menu, chooser, parser);
+   hashPut(item_olc_table, type, data);
+ }
+ 
+ void iedit_menu(SOCKET_DATA *sock, OBJ_DATA *obj) {
+   iedit_show_types(sock, obj);
+   text_to_buffer(sock, 
+ 		 "\r\n"
+ 		 "    {gE) edit type\r\n"
+ 		 "    D) delete type\r\n");
+ }
+ 
+ int  iedit_chooser(SOCKET_DATA *sock, OBJ_DATA *obj, char option) {
+   switch(toupper(option)) {
+   case 'E':
+     text_to_buffer(sock, "Which item type would you like to edit: ");
+     return IEDIT_EDIT;
+   case 'D':
+     text_to_buffer(sock, "Which item type would you like to delete: ");
+     return IEDIT_DELETE;
+   default: return MENU_CHOICE_INVALID;
+   }
+ }
+ 
+ bool iedit_parser(SOCKET_DATA *sock, OBJ_DATA *obj,int choice, const char *arg){
+   switch(choice) {
+   case IEDIT_EDIT: {
+     ITEM_OLC_DATA *funcs = NULL;
+     if(!objIsType(obj, arg))
+       objSetType(obj, arg);
+     // pull up the OLC functions and see if we can edit the type
+     if((funcs = hashGet(item_olc_table, arg)) != NULL) {
+       void *item_data = objGetTypeData(obj, arg);
+       do_olc(sock, funcs->menu, funcs->chooser, funcs->parser,
+ 	     NULL, NULL, NULL, NULL, item_data);
+     }
+     return TRUE;
+   }
+   case IEDIT_DELETE:
+     objDeleteType(obj, arg);
+     return TRUE;
+   default: return FALSE;
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // initialization of item olc
+ //*****************************************************************************
+ void init_item_olc() {
+   item_olc_table = newHashtable(IEDIT_TABLE_SIZE);
+ }
diff -crN nakedmudv1.5/src/items/iedit.d nakedmudv2.0/src/items/iedit.d
*** nakedmudv1.5/src/items/iedit.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/iedit.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ items/iedit.d items/iedit.o: items/iedit.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h socket.h items/items.h \
+   items/iedit.h olc2/olc.h
diff -crN nakedmudv1.5/src/items/iedit.h nakedmudv2.0/src/items/iedit.h
*** nakedmudv1.5/src/items/iedit.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/iedit.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,28 ----
+ #ifndef IEDIT_H
+ #define IEDIT_H
+ //*****************************************************************************
+ //
+ // iedit.h
+ //
+ // Although it is not core to the functioning of items, we will more likely
+ // than not want to be able to edit their type information in OLC. This will
+ // require a parser, a chooser, and a menu for editing the type information.
+ // Item types can add in their OLC functions via this framework. iedit uses
+ // the OLC2 framework. For more detailed instructions on how to set up an OLC,
+ // users should refer to the OLC2 source headers.
+ //
+ // NOTE: the menu, chooser, and parser should only take the item-specific data,
+ //       and not the WHOLE object! It has been set up this way to encourage
+ //       people to localize all of the data associated with one item type.
+ //
+ //*****************************************************************************
+ 
+ void item_add_olc(const char *type, void *menu, void *chooser, void *parser);
+ 
+ //
+ // these functions will be needed by oedit
+ void iedit_menu(SOCKET_DATA *sock, OBJ_DATA *obj);
+ int  iedit_chooser(SOCKET_DATA *sock, OBJ_DATA *obj, char option);
+ bool iedit_parser(SOCKET_DATA *sock, OBJ_DATA *obj,int choice, const char *arg);
+ 
+ #endif // IEDIT_H
diff -crN nakedmudv1.5/src/items/items.c nakedmudv2.0/src/items/items.c
*** nakedmudv1.5/src/items/items.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/items.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,288 ----
+ //*****************************************************************************
+ //
+ // items.c
+ //
+ // Objects can serve many different functions; they might be containers, they
+ // might be weapons, they might be pieces of clothing... the list goes on and
+ // on. The classification of what type of item the object is is what handles
+ // these sorts of distinctions. This is a general framework for adding new
+ // item types. Contains functions for storing type data on objects. Item types
+ // are expected to be able to handle their own subtyping (if neccessary). 
+ // Objects can be multi-typed (e.g. a desk with a drawer can be both a piece
+ // of furniture and a container).
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../object.h"
+ #include "../auxiliary.h"
+ #include "../storage.h"
+ 
+ #include "items.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // local functions, datastructures, and defines
+ //*****************************************************************************
+ // this is the size of the table where we store all of the functions for 
+ // creating/deleting/copying/etc... data of item types. Ideally, this will be
+ // about 120% bigger than the total number of item types we have installed.
+ #define TYPE_TABLE_SIZE       50
+ 
+ // objects can have more than one item type; this is the size of the table
+ // that holds all of the item types for a single object. I'm doubtful an item
+ // will ever have more than 2-3 types, so 5 is a very generous size
+ #define ITEM_TABLE_SIZE        5
+ 
+ // a table of all our item types, and their assocciated new/delete/etc.. funcs
+ HASHTABLE *type_table = NULL;
+ 
+ //
+ // this is what will go into our type_data table
+ typedef struct item_func_data {
+   void          *(* new)();
+   void        (* delete)(void *data);
+   void         *(* copy)(void *data);
+   void        (* copyto)(void *from, void *to);
+   STORAGE_SET *(* store)(void *data);
+   void         *(* read)(STORAGE_SET *set);
+ } ITEM_FUNC_DATA;
+ 
+ 
+ //
+ // create a new structure for holding item type functions
+ ITEM_FUNC_DATA *newItemFuncData(void *new, void *delete, void *copyTo,
+ 				void *copy, void *store, void *read) {
+   ITEM_FUNC_DATA *data = malloc(sizeof(ITEM_FUNC_DATA));
+   data->new    = new;
+   data->delete = delete;
+   data->copy   = copy;
+   data->copyto = copyTo;
+   data->store  = store;
+   data->read   = read;
+   return data;
+ }
+ 
+ 
+ //
+ // deletes one structure for holding item type functions
+ void deleteItemFuncData(ITEM_FUNC_DATA *data) {
+   free(data);
+ }
+ 
+ //
+ // goes through an object's item table and deletes everything in it. Does
+ // not delete the table itself
+ void clearItemTable(HASHTABLE *table) {
+   // if our hashtable isn't empty, we have to make sure 
+   // we delete all of the data within it
+   if(hashSize(table) > 0) {
+     HASH_ITERATOR *hash_i = newHashIterator(table);
+     const char       *key = NULL;
+     void             *val = NULL;
+     // delete the contents of our hashtable
+     ITERATE_HASH(key, val, hash_i) {
+       ITEM_FUNC_DATA *funcs = hashGet(type_table, key);
+       funcs->delete(hashRemove(table, key));
+     }
+     deleteHashIterator(hash_i);
+   }
+ }
+ 
+ //
+ // copies the contents of one item table over to another. clears the destination
+ // table first.
+ void copyItemTableTo(HASHTABLE *from, HASHTABLE *to) {
+   clearItemTable(to);
+   // if the table we're copying has contents, go throug hand copy them all
+   if(hashSize(from) > 0) {
+     HASH_ITERATOR *hash_i = newHashIterator(from);
+     const char       *key = NULL;
+     void             *val = NULL;
+     // copy all the contents
+     ITERATE_HASH(key, val, hash_i) {
+       ITEM_FUNC_DATA *funcs = hashGet(type_table, key);
+       hashPut(to, key, funcs->copy(val));
+     }
+     deleteHashIterator(hash_i);
+   }
+ }
+ 
+ //
+ // Creates a new item table and copies the contents of the old one 
+ // over to the new one 
+ HASHTABLE *copyItemTable(HASHTABLE *table) {
+   HASHTABLE *newtable = newHashtable(ITEM_TABLE_SIZE);
+   copyItemTableTo(table, newtable);
+   return newtable;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // auxiliary data
+ //*****************************************************************************
+ typedef struct item_data {
+   HASHTABLE *item_table;
+ } ITEM_DATA;
+ 
+ ITEM_DATA *newItemData() {
+   ITEM_DATA *data  = malloc(sizeof(ITEM_DATA));
+   data->item_table = newHashtable(ITEM_TABLE_SIZE);
+   return data;
+ }
+ 
+ void deleteItemData(ITEM_DATA *data) {
+   clearItemTable(data->item_table);
+   deleteHashtable(data->item_table);
+   free(data);
+ }
+ 
+ void itemDataCopyTo(ITEM_DATA *from, ITEM_DATA *to) {
+   copyItemTableTo(from->item_table, to->item_table);
+ }
+ 
+ ITEM_DATA *itemDataCopy(ITEM_DATA *data) {
+   ITEM_DATA *newdata = newItemData();
+   itemDataCopyTo(data, newdata);
+   return newdata;
+ }
+ 
+ STORAGE_SET *itemDataStore(ITEM_DATA *data) {
+   STORAGE_SET       *set = new_storage_set();
+   // if we have a type or more, go through them all and store 'em
+   if(hashSize(data->item_table) > 0) {
+     STORAGE_SET_LIST *list = new_storage_list();
+     HASH_ITERATOR  *hash_i = newHashIterator(data->item_table);
+     ITEM_FUNC_DATA  *funcs = NULL;
+     const char        *key = NULL;
+     void              *val = NULL;
+ 
+     // store all of our item type data
+     ITERATE_HASH(key, val, hash_i) {
+       STORAGE_SET *one_set = new_storage_set();
+       funcs = hashGet(type_table, key);
+       store_string(one_set, "type", key);
+       store_set(one_set, "data", funcs->store(val));
+       storage_list_put(list, one_set);
+     }
+     deleteHashIterator(hash_i);
+ 
+     store_list(set, "types", list);
+   }
+   return set;
+ }
+ 
+ 
+ ITEM_DATA *itemDataRead(STORAGE_SET *set) {
+   ITEM_DATA         *data = newItemData();
+   STORAGE_SET_LIST *types = read_list(set, "types");
+   ITEM_FUNC_DATA   *funcs = NULL;
+   STORAGE_SET  *one_entry = NULL;
+ 
+   // go through each entry and parse the item type
+   while( (one_entry = storage_list_next(types)) != NULL) {
+     const char      *type = read_string(one_entry, "type");
+     // make sure the type is valid
+     if((funcs = hashGet(type_table, type)) == NULL) 
+       continue;
+     STORAGE_SET *type_set = read_set(one_entry, "data");
+     hashPut(data->item_table, type, funcs->read(type_set));
+   }
+   return data;
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // implementation of items.h
+ //*****************************************************************************
+ void init_items(void) {
+   type_table = newHashtable(TYPE_TABLE_SIZE);
+   auxiliariesInstall("type_data",
+ 		     newAuxiliaryFuncs(AUXILIARY_TYPE_OBJ, newItemData, 
+ 				       deleteItemData, itemDataCopyTo,
+ 				       itemDataCopy, itemDataStore, 
+ 				       itemDataRead));
+ 
+   // initialize item olc
+   extern void init_item_olc(void); init_item_olc();
+ 
+   // now, initialize our basic items types
+   extern void init_container(); init_container();
+   extern void init_portal();    init_portal();
+   extern void init_furniture(); init_furniture();
+   extern void init_worn();      init_worn();
+ }
+ 
+ void item_add_type(const char *type, 
+ 		   void *new,    void *delete,
+ 		   void *copyTo, void *copy, 
+ 		   void *store,  void *read) {
+   ITEM_FUNC_DATA *funcs = NULL;
+   // first, make sure no item type by this name already
+   // exists. If one does, delete it so it can be replaced
+   if((funcs = hashRemove(type_table, type)) != NULL)
+     deleteItemFuncData(funcs);
+   funcs = newItemFuncData(new, delete, copyTo, copy, store, read);
+   hashPut(type_table, type, funcs);
+ }
+ 
+ LIST *itemTypeList(void) {
+   LIST *list = newList();
+   HASH_ITERATOR *hash_i = newHashIterator(type_table);
+   const char       *key = NULL;
+   void             *val = NULL;
+   ITERATE_HASH(key, val, hash_i)
+     listPutWith(list, strdup(key), strcasecmp);
+   deleteHashIterator(hash_i);
+   return list;
+ }
+ 
+ void *objGetTypeData(OBJ_DATA *obj, const char *type) {
+   ITEM_DATA *data = objGetAuxiliaryData(obj, "type_data");
+   return hashGet(data->item_table, type);
+ }
+ 
+ void objSetType(OBJ_DATA *obj, const char *type) {
+   ITEM_FUNC_DATA *funcs = hashGet(type_table, type);
+   ITEM_DATA *data       = objGetAuxiliaryData(obj, "type_data");
+   void *old_item_data   = hashGet(data->item_table, type);
+   if(old_item_data) return;
+   else hashPut(data->item_table, type, funcs->new());
+ }
+ 
+ void objDeleteType(OBJ_DATA *obj, const char *type) {
+   ITEM_FUNC_DATA *funcs = hashGet(type_table, type);
+   ITEM_DATA *data       = objGetAuxiliaryData(obj, "type_data");
+   void *old_item_data   = hashRemove(data->item_table, type);
+   if(old_item_data) funcs->delete(old_item_data);
+ }
+ 
+ bool objIsType(OBJ_DATA *obj, const char *type) {
+   ITEM_DATA *data = objGetAuxiliaryData(obj, "type_data");
+   return hashIn(data->item_table, type);
+ }
+ 
+ const char *objGetTypes(OBJ_DATA *obj) {
+   static char buf[MAX_BUFFER];
+   ITEM_DATA *data = objGetAuxiliaryData(obj, "type_data");
+   if(hashSize(data->item_table) == 0)
+     sprintf(buf, "none");
+   else {
+     *buf = '\0';
+     HASH_ITERATOR *hash_i = newHashIterator(data->item_table);
+     const char       *key = NULL;
+     void             *val = NULL;
+     int             count = 0;
+ 
+     ITERATE_HASH(key, val, hash_i) {
+       sprintf(buf, "%s%s%s", buf, (count > 0 ? ", " : ""), key);
+       count++;
+     }
+     deleteHashIterator(hash_i);
+   }
+   return buf;
+ }
diff -crN nakedmudv1.5/src/items/items.d nakedmudv2.0/src/items/items.d
*** nakedmudv1.5/src/items/items.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/items.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ items/items.d items/items.o: items/items.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h object.h auxiliary.h \
+   storage.h items/items.h
diff -crN nakedmudv1.5/src/items/items.h nakedmudv2.0/src/items/items.h
*** nakedmudv1.5/src/items/items.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/items.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,89 ----
+ #ifndef ITEMS_H
+ #define ITEMS_H
+ //*****************************************************************************
+ //
+ // items.h
+ //
+ // Objects can serve many different functions; they might be containers, they
+ // might be weapons, they might be pieces of clothing... the list goes on and
+ // on. The classification of what type of item the object is is what handles
+ // these sorts of distinctions. This is a general framework for adding new
+ // item types. Contains functions for storing type data on objects. Item types
+ // are expected to be able to handle their own subtyping (if neccessary). 
+ // Objects can be multi-typed (e.g. a desk with a drawer can be both a piece
+ // of furniture and a container).
+ //
+ //*****************************************************************************
+ 
+ //
+ // prepare the items module for use
+ void init_items(void);
+ 
+ //
+ // install a new item type. type should be the name of the item type.
+ //
+ // new should create a new datastructure to hold data for the object assocciated
+ // with its item type. It should take no arguments. The form of the function
+ // should be as follows:
+ //    itemdata *newItemData()
+ //
+ // delete should take in the datastructure used for holding data assocciated
+ // with the item type, and free it all from memory. The function should take
+ // a form as follows:
+ //    void deleteItemData(itemdata *data)
+ //
+ // copyTo should take a pointer from one itemdata and copy all of its
+ // information over to a pointer to another itemdata. The function should take
+ // a form as follows:
+ //    void itemDataCopyTo(itemdata *from, itemdata *to)
+ //
+ // copy should return a deep copy (newly allocated memory) of the supplied
+ // itemdata. The function should take a form as follows:
+ //    itemdata *itemDataCopy(itemdata *data)
+ //
+ // store should return a storage set for storing data assocciated with the
+ // item type for the object to disk. The function should take a form as
+ // follows:
+ //    STORAGE_SET *itemDataStore(itemdata *data)
+ //
+ // read should take in a storage set and, from it, parse a new instance
+ // of itemdata. The function should take a form as follows:
+ //    itemdata *itemDataRead(STORAGE_SET *set)
+ void item_add_type(const char *type, 
+ 		   void *new,    void *delete,
+ 		   void *copyTo, void *copy, 
+ 		   void *store,  void *read);
+ 
+ //
+ // Build a list of all the current item types. Item types are listed in
+ // alphabetical order. This list and all its contents must be deleted after 
+ // use. For a quick one-line deletion, try: 
+ //   deleteListWith(list, free)
+ LIST *itemTypeList(void);
+ 
+ //
+ // returns the item data with the specified type for the object. 
+ // if the object is not of type item, return NULL.
+ void *objGetTypeData(OBJ_DATA *obj, const char *type);
+ 
+ //
+ // Set the item to be of the specified type. 
+ // A new datastructure for the type data is created.
+ void objSetType(OBJ_DATA *obj, const char *type);
+ 
+ //
+ // If an object was of the specified type, no longer have the object
+ // be of that type.
+ void objDeleteType(OBJ_DATA *obj, const char *type);
+ 
+ //
+ // returns TRUE if the object is the specified type of object
+ bool objIsType(OBJ_DATA *obj, const char *type);
+ 
+ //
+ // returns a comma-separated list of the item types this object currently
+ // has. the list is written to a static buffer, so players don't have to
+ // worry about freeing the string after use
+ const char *objGetTypes(OBJ_DATA *obj);
+ 
+ #endif // ITEMS_H
diff -crN nakedmudv1.5/src/items/module.mk nakedmudv2.0/src/items/module.mk
*** nakedmudv1.5/src/items/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/items/module.mk	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ SRC  += items/items.c items/portal.c items/iedit.c items/container.c \
+ 	items/furniture.c items/worn.c
